summaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
author Steven Voges2022-08-18 08:55:37 +0200
committer Willy Sudiarto Raharjo2022-08-20 05:06:40 +0200
commit9574f12ae2fd742729ce75601319dad34665185a (patch)
treede83afd4e8e9f6c6e72f37701ad5eec37573f082
parent18ce2e1a430132541690f6fbf9eae0941face1a2 (diff)
downloadslackbuilds-9574f12ae2fd742729ce75601319dad34665185a.tar.gz
libraries/md4c: Added (Markdown for C)
Signed-off-by: Dave Woodfall <dave@slackbuilds.org> Signed-off-by: Willy Sudiarto Raharjo <willysr@slackbuilds.org>
-rw-r--r--libraries/md4c/README40
-rw-r--r--libraries/md4c/md4c.SlackBuild110
-rw-r--r--libraries/md4c/md4c.info10
-rw-r--r--libraries/md4c/slack-desc19
4 files changed, 179 insertions, 0 deletions
diff --git a/libraries/md4c/README b/libraries/md4c/README
new file mode 100644
index 0000000000..20c0f53f80
--- /dev/null
+++ b/libraries/md4c/README
@@ -0,0 +1,40 @@
+MD4C stands for "Markdown for C" and that's exactly what this project
+is about.
+
+MD4C is Markdown parser implementation in C, with the following
+features:
+
+ *Compliance: Generally, MD4C aims to be compliant to the latest
+version of CommonMark specification. Currently, we are fully compliant
+to CommonMark 0.30.
+
+ *Extensions: MD4C supports some commonly requested and accepted
+extensions. See below.
+
+ *Performance: MD4C is very fast.
+
+ *Compactness: MD4C parser is implemented in one source file and
+one header file. There are no dependencies other than standard C
+library.
+
+ *Embedding: MD4C parser is easy to reuse in other projects, its
+API is very straightforward: There is actually just one function,
+md_parse().
+
+ *Push model: MD4C parses the complete document and calls few
+callback functions provided by the application to inform it about a
+start/end of every block, a start/end of every span, and with any
+textual contents.
+
+ *Portability: MD4C builds and works on Windows and
+POSIX-compliant OSes. (It should be simple to make it run also on
+most other platforms, at least as long as the platform provides C
+standard library, including a heap memory management.)
+
+ *Encoding: MD4C by default expects UTF-8 encoding of the input
+document. But it can be compiled to recognize ASCII-only control
+characters (i.e. to disable all Unicode-specific code), or (on
+Windows) to expect UTF-16 (i.e. what is on Windows commonly called
+just "Unicode"). See more details below.
+
+ *Permissive license: MD4C is available under the MIT license.
diff --git a/libraries/md4c/md4c.SlackBuild b/libraries/md4c/md4c.SlackBuild
new file mode 100644
index 0000000000..1c3e48f377
--- /dev/null
+++ b/libraries/md4c/md4c.SlackBuild
@@ -0,0 +1,110 @@
+#!/bin/bash
+
+# Slackware build script for <appname>
+
+# Copyright 2022 Steven Voges <svoges.sbo@gmail.com>
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+cd $(dirname $0) ; CWD=$(pwd)
+
+PRGNAM=md4c
+SRCNAM=md4c-release
+VERSION=${VERSION:-0.4.8}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+PKGTYPE=${PKGTYPE:-tgz}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+if [ ! -z "${PRINT_PACKAGE_NAME}" ]; then
+ echo "$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE"
+ exit 0
+fi
+
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $SRCNAM-$VERSION
+tar xvf $CWD/$SRCNAM-$VERSION.tar.gz
+cd $SRCNAM-$VERSION
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+mkdir -p build
+cd build
+ cmake \
+ -DCMAKE_C_FLAGS:STRING="$SLKCFLAGS" \
+ -DCMAKE_INSTALL_PREFIX=/usr \
+ -DCMAKE_BUILD_TYPE=Release ..
+ make
+ make install/strip DESTDIR=$PKG
+cd ..
+
+#md4c doesn't accept the flag for DMAN_INSTALL_DIR, so we do it manually:
+mv $PKG/usr/share/man $PKG/usr/
+rmdir $PKG/usr/share
+
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+find $PKG/usr/man -type f -exec gzip -9 {} \;
+for i in $( find $PKG/usr/man -type l ) ; do ln -s $( readlink $i ).gz $i.gz ; rm $i ; done
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a \
+ *.md \
+ $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE
diff --git a/libraries/md4c/md4c.info b/libraries/md4c/md4c.info
new file mode 100644
index 0000000000..08315ace4d
--- /dev/null
+++ b/libraries/md4c/md4c.info
@@ -0,0 +1,10 @@
+PRGNAM="md4c"
+VERSION="0.4.8"
+HOMEPAGE="https://github.com/mity/md4c"
+DOWNLOAD="https://github.com/mity/md4c/archive/release-0.4.8/md4c-release-0.4.8.tar.gz"
+MD5SUM="3a3d87255705dd812a679d329638a92d"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+REQUIRES=""
+MAINTAINER="Steven Voges"
+EMAIL="svoges.sbo@gmail.com"
diff --git a/libraries/md4c/slack-desc b/libraries/md4c/slack-desc
new file mode 100644
index 0000000000..03eafb51b0
--- /dev/null
+++ b/libraries/md4c/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+md4c: md4c (Markdown for C)
+md4c:
+md4c: C Markdown parser. Fast. SAX-like interface. Compliant to CommonMark
+md4c: specification.
+md4c:
+md4c: Homepage: https://github.com/mity/md4c
+md4c:
+md4c:
+md4c:
+md4c:
+md4c: